<?php
/*
 * Author: Víctor Sánchez Sánchez (victorsanchez2@gmail.com - www.victorsanchez2.com)
 *
 * This file is part of FootballRankingGenerator.
 *
 * FootballRankingGenerator is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * FootballRankingGenerator is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with FootballRankingGenerator.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>

<?php include('cabecera.inc.php'); ?>

	<a href="index.php">Volver<br /><br /></a>

	<?php

		$num_equipos=20;
		$num_partidos=$num_equipos/2;
		define("PRIMERO_COL1",0);
		define("PRIMERO_COL2",$num_equipos-1);
		define("ULTIMO_COL1",$num_partidos-1); //Ultimo de la columna 1. La primera columna tiene las posiciones de 0 a 9 y la segunda de 10 a 19
		define("ULTIMO_COL2",$num_partidos);
		$comodin=ULTIMO_COL1;	//El comodin estara identificado con el ultimo numero. Se comienza a contar en 0, por eso se resta 1
		
		include_once("datos_bd.inc.php");
		connect_db($connection);
		mysql_select_db($mysql_instance,$connection);


		//Cargar la primera jornada en el array
		$jornada_inicial=array(0,1,2,3,4,5,6,7,8,19,9,10,11,12,13,14,15,16,17,18);
		$jornada=$jornada_inicial;
		$jornada_tmp=array(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

		$query="SELECT count(*) FROM $mysql_tabla_jornada";
		$result=mysql_query($query,$connection);
		if(mysql_errno($connection)!=0){
			$numerror=mysql_errno($connection);
			$descrerror=mysql_error($connection);
			echo '<div align="center"><strong>Error interno al insertar el calendario.</strong>.</div>';
			echo "ERROR $numerror: $descrerror  <br />";
		}
		$v=mysql_fetch_row($result);
		if($v[0]>0){
			echo "ERROR: La tabla $mysql_tabla_jornada no esta vacía, vacíela primero.<br />";
			mysql_close($connection);
			exit(1);
		}

		echo "<br />Jornada=1:<br />";
		for($j=0;$j<$num_partidos;$j++){
			$equipo_local=$jornada[PRIMERO_COL1+$j];
			$equipo_visitante=$jornada[PRIMERO_COL2-$j];
			$query="INSERT INTO $mysql_tabla_jornada (`num_jornada`,`num_partido`,`equipo_local`,`equipo_visitante`) VALUES (1,$j,$equipo_local,$equipo_visitante);";
			//El equipo local y el visitante se empiezan a numerar desde 0, tenerlo en cuenta a la hora de visualizarlo
			$result=mysql_query($query,$connection);
			if(mysql_errno($connection)!=0){
				$numerror=mysql_errno($connection);
				$descrerror=mysql_error($connection);
				echo '<div align="center"><strong>Error interno al insertar el calendario.</strong>.</div>';
				echo "ERROR $numerror: $descrerror  <br />";
			}
			else
				echo "QUERY=$query<BR />";
		}

		for($i=2;$i<$num_equipos;$i++){
			echo "<br />Jornada=$i:<br />";
			if($i%2==0){	//Jornadas pares
				/* Pseudocodigo:
						* Cargar la columna anterior
						* El ultimo de la primera columna (comodin), para a ser el primero de la primera columna
						* El resto de la primera columna bajan un lugar
						* Intercambiar las columnas
				*/
				//Establecer la primera columna
				for($j=0;$j<$num_partidos;$j++){
					if($j!=ULTIMO_COL1)
						$jornada_tmp[$j+1]=$jornada[$j];
					else
						$jornada_tmp[PRIMERO_COL1]=$jornada[ULTIMO_COL1];
				}

				//Cargar la segunda columna
				for($j=0;$j<$num_partidos;$j++){
					$jornada_tmp[$j+$num_partidos]=$jornada[$j+$num_partidos];
				}
				//Intercambiar las columnas
				for($j=0;$j<$num_partidos;$j++){
					$jornada[$num_equipos-$j-1]=$jornada_tmp[$j];
				}
				for($j=$num_equipos;$j>$num_partidos;$j--){
					$jornada[$num_equipos-$j]=$jornada_tmp[$j-1];
				}
			}
			else{	//Jornadas impares
				/* Pseudocodigo:
						* Cargar la columna impar anterior
						* Rotacion antihoraria, sin mover el comodin, que se encuentra el último de la primera columna
				*/
				//Coger la jornada impar anterior
				if($jornada_impar_anterior==NULL)
					$jornada=$jornada_inicial;
				else
					$jornada=$jornada_impar_anterior;


				//Rotacion antihoraria sin mover ni contar el comodin
				for($j=0;$j<$num_equipos;$j++){
					if($j==$comodin)
						$jornada_tmp[$j]=$jornada[$j];	//Se deja en la misma posicion
					elseif($j==ULTIMO_COL1-1)
						$jornada_tmp[($j+2)%$num_equipos]=$jornada[$j];
					else
						$jornada_tmp[($j+1)%$num_equipos]=$jornada[$j];
				}
				for($j=0;$j<$num_equipos;$j++){
					$jornada[$j]=$jornada_tmp[$j];
				}
				$jornada_impar_anterior=$jornada;
			}

			//En la penúltima y última jornada, intercambiar el comodín con su rival
			if($i==$num_equipos-2){
				//Intercambiar el comodin con su rival
 				$tmp=$jornada[PRIMERO_COL1];
 				$jornada[PRIMERO_COL1]=$jornada[PRIMERO_COL2];
 				$jornada[PRIMERO_COL2]=$tmp;
			}
			if($i==$num_equipos-1){
				//Intercambiar el comodin con su rival
				$tmp=$jornada[ULTIMO_COL1];
				$jornada[ULTIMO_COL1]=$jornada[ULTIMO_COL2];
				$jornada[ULTIMO_COL2]=$tmp;
			}

			//Insertar en la base de datos los partidos de cada jornada
			for($j=0;$j<$num_partidos;$j++){
				$equipo_local=$jornada[PRIMERO_COL1+$j];
				$equipo_visitante=$jornada[PRIMERO_COL2-$j];
				$query="INSERT INTO $mysql_tabla_jornada (`num_jornada`,`num_partido`,`equipo_local`,`equipo_visitante`) VALUES ($i,$j,$equipo_local,$equipo_visitante);";
				//El equipo local y el visitante se empiezan a numerar desde 0, tenerlo en cuenta a la hora de visualizarlo
				$result=mysql_query($query,$connection);
				if(mysql_errno($connection)!=0){
					$numerror=mysql_errno($connection);
					$descrerror=mysql_error($connection);
					echo '<div align="center"><strong>Error interno al insertar el calendario.</strong>.</div>';
					echo "ERROR $numerror: $descrerror  <br />";
				}
				else
					echo "QUERY=$query<BR />";
			}
		}

		echo '<br />Comenzando a generar la 2a vuelta...<br />';

		//Generar la segunda vuelta intercambiando los equipos que se enfrentaron en la primera
		for($i=1;$i<$num_equipos;$i++){

			$jornada=$i+$num_equipos-1;
			echo "<br />Jornada=$jornada:<br />";

			$campos="equipo_local,equipo_visitante";
			$query="SELECT $campos FROM $mysql_tabla_jornada WHERE num_jornada='$i'";

			if(ejecutar_query($connection,$query,$result_jornada,"Error interno al insertar el calendario.")==0){
				while($v=mysql_fetch_row($result_jornada)){

					//Obtener los equipos que se enfrentaron en la primera vuelta y alternarlos
					$equipo_visitante_2a_vuelta=$v[0];
					$equipo_local_2avuelta=$v[1];

					$query="INSERT INTO $mysql_tabla_jornada (`num_jornada`,`num_partido`,`equipo_local`,`equipo_visitante`) VALUES ($jornada,$j,$equipo_local_2avuelta,$equipo_visitante_2a_vuelta);";
					//El equipo local y el visitante se empiezan a numerar desde 0, tenerlo en cuenta a la hora de visualizarlo
					if(ejecutar_query($connection,$query,$result,"Error interno al insertar el calendario.")==0){
						echo "QUERY=$query<BR />";
					}
				}
			}
		}

		mysql_close($connection);
	?>

	<a href="index.php"><br />Volver<br /></a>

<?php include('pie_pagina.inc.php'); ?>

</body>
</html>